//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include <stdio.h>
#include <condefs.h>
#include <stdlib.h>
#include <iostream.h>
#include <conio.h>
#include "about.h"
//---------------------------------------------------------------------------
#pragma link "OnBask"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	Yazici=new TPrinter;
    KagitXBirIncPix=GetDeviceCaps(Yazici->Handle, LOGPIXELSX);
    KagitYBirIncPix=GetDeviceCaps(Yazici->Handle, LOGPIXELSY);
   	// Kagidin Boyu ve Eni mm. olarak
    KagitBoyu=Yazici->PageHeight; KagitBoyuMM=INCHMM*KagitBoyu/KagitYBirIncPix;
    KagitEni=Yazici->PageWidth; KagitEniMM=INCHMM*KagitEni/KagitXBirIncPix;
    char s[100];
    sprintf(s,"Kagidin Eni=%.0f, Boyu=%.0f mm.", KagitEniMM, KagitBoyuMM);
    KagitBilgi->Caption=s;
    // Kagitin en/boy orani
    KagitEnBoyOrani=KagitEniMM/KagitBoyuMM;
    // Kagittaki mm. ly Yaziciya evirme orani
    // sonu yazicidaki pixel sayisi olarak ikacak
    YaziciyaCevirmeOraniX=KagitXBirIncPix/INCHMM;
    YaziciyaCevirmeOraniY=KagitYBirIncPix/INCHMM;
}
//---------------------------------------------------------------------------
int TForm1::EkranaCevir(int x)
{
	return x*EkranaCevirmeOrani;
}
//---------------------------------------------------------------------------
int TForm1::YaziciyaCevirX(int x)
{

	return x*YaziciyaCevirmeOraniX;
}
//---------------------------------------------------------------------------
int TForm1::YaziciyaCevirY(int x)
{
	return x*YaziciyaCevirmeOraniY;
}
//---------------------------------------------------------------------------
void TForm1::Ciz()
{
    // OnBaski Panelinin Boyu ve Eni Pixel olarak
    OnBaskiBoyu=ClientHeight*.9; OnBaskiEni=OnBaskiBoyu*KagitEnBoyOrani;
    // OnBaski Panelinin yerini ve boyutlarini ayarla
    OnBaski1->SetBounds(10, Height*.05, OnBaskiEni, OnBaskiBoyu);
    Golge->SetBounds(10, Height*.05, OnBaskiEni+7, OnBaskiBoyu+7);
	// OnBaski Panelinin Boyu ve Eni mm. olarak
	OnBaskiBoyuMM=INCHMM*OnBaskiBoyu/PixelsPerInch;
    OnBaskiEniMM=INCHMM*OnBaskiEni/PixelsPerInch;
    // Kagit boyutundan ekrandaki boyuta gemek iin evirme orani
    // sonuc ekrandaki pixel sayisi cinsinden ikacak sekilde
    EkranaCevirmeOrani=(OnBaskiBoyuMM/KagitBoyuMM)*(PixelsPerInch/INCHMM);
//   	sprintf(s,"Panel boy=%d", OnBaskiBoyu);
//		Application->MessageBox(s,"Mesaj", 1);
	OnBaski1->Repaint();
    TaslakCiz();
}
//---------------------------------------------------------------------------
void TForm1::BarkodCiz(int x, int y, char *BarBilgi)
{
    static int BasSon[16]={1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0 };
    static int Barkodlar[][16]={
    	{1, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0}, // 0
        {1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 1, 1, 0}, // 1
        {1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 1, 0, 1, 1, 1, 0}, // 2
        {1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0}, // 3
        {1, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0}, // 4
        {1, 1, 1, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0}, // 5
        {1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0}, // 6
        {1, 0, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0}, // 7
        {1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 0}, // 8
        {1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 0}, // 9
    };

    int Kalin=atoi(Kalinlik->Text.c_str());
    Yazici->Canvas->Pen->Width=Kalin;
    int YukseklikY=YaziciyaCevirY( atoi(Yukseklik->Text.c_str()) );

    unsigned int i, ii, j;
    for(i=0; i<16; i++) {
    	x+=Kalin;
        if ( !BasSon[i] ) continue;
        Yazici->Canvas->MoveTo(x, y); Yazici->Canvas->LineTo(x, y+YukseklikY);
    }
    for(i=0; i<strlen(BarBilgi); i++) {
    	ii=BarBilgi[i]-48;
        for(j=0; j<16; j++) {
        	x+=Kalin;
            if( ! Barkodlar[ii][j] ) continue;
            Yazici->Canvas->MoveTo(x, y); Yazici->Canvas->LineTo(x, y+YukseklikY);
        }
    }
    for(i=0; i<16; i++) {
    	x+=Kalin;
        if ( !BasSon[i] ) continue;
        Yazici->Canvas->MoveTo(x, y); Yazici->Canvas->LineTo(x, y+YukseklikY);
    }

    Yazici->Canvas->Pen->Width=1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EtiketBoyuChange(TObject *Sender)
{
	Ciz();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EtiketEniChange(TObject *Sender)
{
	Ciz();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EtiketAraYatayChange(TObject *Sender)
{
	Ciz();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EtiketAraDikeyChange(TObject *Sender)
{
	Ciz();
}
//---------------------------------------------------------------------------
void TForm1::TaslakCiz()
{
    int Kalin=atoi(Kalinlik->Text.c_str());
    int BarkodUzunlukMM=(strlen(BitisNo->Text.c_str())+2)*16*Kalin/YaziciyaCevirmeOraniY;
    int BarkodUzunlukPix=EkranaCevir(BarkodUzunlukMM);
	int SayiUzunlukMM=strlen(BitisNo->Text.c_str())*-Yazici->Canvas->Font->Height/YaziciyaCevirmeOraniX;
    int SayiUzunlukPix=EkranaCevir(SayiUzunlukMM);

	int x=0, y=0, x1, y1, x2, y2, xx1, yy1;

    int iEtiketEni=EkranaCevir( atoi(EtiketEni->Text.c_str()) );
    int iEtiketBoyu=EkranaCevir( atoi(EtiketBoyu->Text.c_str()) );
    int iEtiketAraYatay=EkranaCevir( atoi(EtiketAraYatay->Text.c_str()) );
    int iEtiketAraDikey=EkranaCevir( atoi(EtiketAraDikey->Text.c_str()) );
	int YukseklikE=EkranaCevir( atoi(Yukseklik->Text.c_str()) );

    int xx=(OnBaskiEni+iEtiketAraYatay)/(iEtiketEni + iEtiketAraYatay);
	int yy=(OnBaskiBoyu+iEtiketAraDikey)/+(iEtiketBoyu + iEtiketAraDikey);

    for(int i=0; i<yy; i++)
		for(int j=0; j<xx; j++) {
            x1=x+j*(iEtiketEni+iEtiketAraYatay); y1=y+i*(iEtiketBoyu+iEtiketAraDikey);
            x2=x1+iEtiketEni; y2=y1+iEtiketBoyu;
            OnBaski1->Canvas->Rectangle( x1, y1, x2, y2);

            xx1=x1+(x2-x1-BarkodUzunlukPix)/2; yy1=y1+(y2-y1-YukseklikE*1.5)/2;
    		OnBaski1->Canvas->Rectangle( xx1, yy1, xx1+BarkodUzunlukPix, yy1+YukseklikE*1.5);

            xx1=x1+(x2-x1-SayiUzunlukPix)/2; yy1+=YukseklikE*1.1;
    		OnBaski1->Canvas->MoveTo( xx1, yy1);
			OnBaski1->Canvas->LineTo( xx1+SayiUzunlukPix, yy1);

        }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::YazdirClick(TObject *Sender)
{
	char bilgi[10]; int ibilgi;
    int Kalin=atoi(Kalinlik->Text.c_str());
    int BarkodUzunlukMM=(strlen(BitisNo->Text.c_str())+2)*16*Kalin;
    int BarkodUzunlukPix=BarkodUzunlukMM;
    int ibilgison=atoi( BitisNo->Text.c_str() );
	int ibilgibas=atoi( BaslangicNo->Text.c_str() );
    ibilgi=ibilgibas;
    strcpy(bilgi, BitisNo->Text.c_str());

    int x=1, y=1, x1, y1, x2, y2, xx1, yy1, i, j;

    int iEtiketEni=YaziciyaCevirX( atoi(EtiketEni->Text.c_str()) );
    int iEtiketBoyu=YaziciyaCevirY( atoi(EtiketBoyu->Text.c_str()) );
    int iEtiketAraYatay=YaziciyaCevirX( atoi(EtiketAraYatay->Text.c_str()) );
    int iEtiketAraDikey=YaziciyaCevirY( atoi(EtiketAraDikey->Text.c_str()) );
    int YukseklikY=YaziciyaCevirY( atoi(Yukseklik->Text.c_str()) );

    int SayiUzunlukPix=strlen(BitisNo->Text.c_str())*-Yazici->Canvas->Font->Height;
    int YukseklikE=YaziciyaCevirY( atoi(Yukseklik->Text.c_str()) );

    int xx=(KagitEni+iEtiketAraYatay)/(iEtiketEni + iEtiketAraYatay);
	int yy=(KagitBoyu+iEtiketAraDikey)/+(iEtiketBoyu + iEtiketAraDikey);

    // Yazdirma basliyor
    if( !PrintDialog1->Execute() ) {
    	Application->MessageBox("Print islemi iptal edildi !", "Mesaj", 1);
        return;
    }
	Yazici->Title="Barkodlar Geliyoor";
	Yazici->BeginDoc();
    Yazici->Canvas->Rectangle(1, 1, Yazici->PageWidth, Yazici->PageHeight);

    while( ibilgi<ibilgison) {
	    for(i=0; i<yy; i++) {
    		if( ibilgi>=ibilgison ) break;
			for(j=0; j<xx; j++) {
        		if( ibilgi>=ibilgison ) break;
         	   	ibilgi++;
           		x1=x+j*(iEtiketEni+iEtiketAraYatay); y1=y+i*(iEtiketBoyu+iEtiketAraDikey);
           	 	x2=x1+iEtiketEni; y2=y1+iEtiketBoyu;
                Yazici->Canvas->Rectangle( x1, y1, x2, y2);

           		xx1=x1+(x2-x1-BarkodUzunlukPix)/2; yy1=y1+(y2-y1-YukseklikY*1.5)/2;
                sprintf(bilgi, "%d", ibilgi); BarkodCiz(xx1, yy1, bilgi);

                xx1=x1+(x2-x1-SayiUzunlukPix)/2; yy1+=YukseklikE*1.1;
                Yazici->Canvas->TextOut(xx1, yy1, bilgi);
            }
	    }
        if( ibilgi>=ibilgison ) break;
        Yazici->NewPage();
    }

    Yazici->EndDoc();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitisNoChange(TObject *Sender)
{
    Ciz();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Hakknda1Click(TObject *Sender)
{
	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
